import React, { Component, useRef, useState, useEffect } from 'react';
import {StatusBar,View,LayoutAnimation,ScrollView,Linking,Text,TouchableOpacity } from 'react-native';
import Constants from 'expo-constants';
import { List, ListItem } from 'native-base';
import Icon from 'react-native-vector-icons/Entypo';
import StatusbarDetect from './StatusbarDetect';
var Status = StatusbarDetect();
import { useNavigation } from '@react-navigation/native';
import AutoHeightImage from 'react-native-auto-height-image';
import {widthPercentageToDP as wp, heightPercentageToDP as hp} from 'react-native-responsive-screen';
import { FontAwesome, Fontisto, Foundation, Ionicons, MaterialCommunityIcons } from '@expo/vector-icons';
import * as WebBrowser from 'expo-web-browser';
import ActionSheet from "react-native-actions-sheet";
import LottieView from 'lottie-react-native';
export default function(props) {
  const navigation = useNavigation();

  return <Menu {...props} navigation={navigation} />;
}
export  function Menu(props) {
  const actionSheetRef = useRef(null);
  const _handlePressButtonAsync = async (link) => {
    let result = await WebBrowser.openBrowserAsync(link);
  };

  const LottieRef = useRef(null);
  const LottieRef2 = useRef(null);
  const [count,setCount] =useState(0);
  const [delayData,setDelayData] = useState(undefined);
  const [getTime,setGetTime] = useState(new Date());
  const [loadingDelayData,setLoadingDelayData] = useState(true);
  delayData === undefined ? doFetch() : null;
  function doFetch(){
    fetch("https://script.google.com/macros/s/AKfycbyKxch7z7l8e07LXulRHqxjVoIiB13kcgvoToLE-rqlxLmLSKdlmqz0FI1F2EuA7Zfg/exec")
      .then(response => response.text())
      .then(data => {if(data != ""){setDelayData(data.split("^"))}else setDelayData(null)})
      .then(data => LayoutAnimation.easeInEaseOut())
      .then(()=>setGetTime(new Date()))
      .finally(()=>setLoadingDelayData(false));
  }
  useEffect(()=>{
    try{
      LottieRef?.current.play();
      LottieRef2?.current.play();
    }catch(e){}
    
  })
    const { navigation } = props;
    return (
      <View style={{height:"100%",paddingTop: Constants.statusBarHeight,backgroundColor:"white"}}>
        {Status}
        <View style={{alignItems:"center"}}>
          <TouchableOpacity onPress={()=>Linking.openURL("https://www.jr-shikoku.co.jp")}>
            <AutoHeightImage source={require("./assets/Header.png")}  resizeMode='contain' width={wp("100%")}/>
          </TouchableOpacity>
          </View>
        <ScrollView>
          <View style={{flexDirection:"row"}}>
            <TouchableOpacity style={{flex:1,backgroundColor:"#F89038",padding:10,alignItems:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/01_trainbus/sp/")}>
              <MaterialCommunityIcons name="train-car" color="white" size={50}/>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>駅・鉄道情報</Text>
            </TouchableOpacity>
            <TouchableOpacity style={{flex:1,backgroundColor:"#EA4752",padding:10,alignItems:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/01_trainbus/jikoku/sp/#mainprice-box")}>
              <MaterialCommunityIcons name="google-spreadsheet" color="white" size={50}/>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>運賃表</Text>
            </TouchableOpacity>
            <TouchableOpacity style={{flex:1,backgroundColor:"#91C31F",padding:10,alignItems:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/e5489/")}>
              <MaterialCommunityIcons name="clipboard-list-outline" color="white" size={50}/>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>予約(e5489)</Text>
            </TouchableOpacity>
          </View>
          <TouchableOpacity style={{flex:1,backgroundColor:"#0099CC",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/02_information/suspension/sp/")}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>新型コロナウイルスに関するお知らせ</Text>
              <Text style={{color:"white",fontSize:18}}>列車の運行計画・混雑状況・感染症対策への取り組み</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
          <TouchableOpacity /* onPress={()=>alert("まだうごかないよ〜♡ごめんね！！")} */ onPress={() => {actionSheetRef.current?.setModalVisible()}}>
            <View style={{backgroundColor:"#0099CC",borderRadius:5,margin:5,borderColor:"black",borderWidth:2,overflow:"hidden"}}>
              <ScrollView scrollEnabled={false} style={{backgroundColor:"#0099CC",borderRadius:5,maxHeight:300,}}>
                <View style={{padding:10,flexDirection:"row",alignItems:"center"}}>
                  <Text style={{fontSize:30,fontWeight:"bold",color:"white"}}>列車遅延速報EX</Text>
                  <View style={{flex:1}} />
                  {/* <TouchableOpacity style={{padding:10,backgroundColor:"white",alignContent:"center"}} onPress={() => {doFetch()}}>
                    <Text style={{fontSize:20,fontWeight:"bold",color:"#0099CC"}}>最新の情報へ更新</Text>
                  </TouchableOpacity> */}
                  <Text style={{fontSize:30,fontWeight:"bold",color:"white"}}>{getTime ? getTime.toLocaleTimeString('ja-JP').split(":")[0]+":"+getTime.toLocaleTimeString('ja-JP').split(":")[1]: NaN}</Text>
                  <Ionicons name="reload" color="white" size={30} style={{margin:5}} onPress={() => {LayoutAnimation.easeInEaseOut(),setLoadingDelayData(true),doFetch()}}/>
                </View>
                <View style={{padding:10,backgroundColor:"white",borderBottomLeftRadius:5,borderBottomRightRadius:5}}>
                  {loadingDelayData ?
                   <View style={{alignItems:"center"}}>
                    <LottieView ref={LottieRef} style={{ width: 150, height: 150, backgroundColor: '#fff',}} source={require('./assets/51690-loading-diamonds.json')}/>
                  </View> 
                  : delayData ? delayData.map((d)=>{
                    let data = d.split(" ");
                    console.log(data);
                    return (
                      <View style={{flexDirection:"row"}}>
                        <Text style={{flex:15,fontSize:20}}>{data[0].replace("\n","")}</Text>
                        <Text style={{flex:5,fontSize:20}}>{data[1]}</Text>
                        <Text style={{flex:6,fontSize:20}}>{data[3]}</Text>
                      </View>
                    );
                  }) : <Text>現在、5分以上の遅れはありません。</Text>}  
                </View>
              </ScrollView>    
              <View style={{position:"absolute",top:250,alignItems:"center",width:"100%",height:50,backgroundColor:"#007FCC88"}}>
                <View style={{flex:1}}/>
                <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>詳細を見る</Text>
                <View style={{flex:1}}/>
              </View>
            </View>
            
            {/* <View style={{position:"absolute",bottom:0,alignItems:"center",width:"100%",height:"100%",backgroundColor:"#007FCC88"}}>
              <View style={{flex:1}}/>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>準備中...</Text>
              <View style={{flex:1}}/>
            </View> */}
          </TouchableOpacity>
          

          <View style={{flexDirection:"row"}}>
            <TouchableOpacity style={{flex:1,backgroundColor:"#AD7FA8",borderColor:"#0099CC",padding:10,borderWidth:1,margin:2,alignItems:"center"}} onPress={()=>_handlePressButtonAsync("https://www.jr-eki.com/ticket/brand")}>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>トクトク切符</Text>
              <Foundation name="ticket" color="white" size={50}/>
            </TouchableOpacity>
            <TouchableOpacity style={{flex:1,backgroundColor:"#8F5902",borderColor:"#0099CC",padding:10,borderWidth:1,margin:2,alignItems:"center"}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/01_trainbus/event_train/sp/")}>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>観光列車</Text>
              <FontAwesome name="first-order" color="white" size={50}/>
            </TouchableOpacity>
            <TouchableOpacity style={{flex:1,backgroundColor:"#888A85",borderColor:"#0099CC",padding:10,borderWidth:1,margin:2,alignItems:"center"}} onPress={()=>_handlePressButtonAsync("https://www.jr-eki.com/tour/brand")}>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>旅行ツアー</Text>
              <Ionicons name="flag" color="white" size={50}/>
            </TouchableOpacity>
          </View>
          <TouchableOpacity style={{flex:1,backgroundColor:"#0099CC",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/sp/index.html#menu-box")}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>臨時列車などのお知らせ</Text>
              <Text style={{color:"white",fontSize:18}}>区間縮小・計画運休・イベント・季節臨時列車など</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
          <TouchableOpacity style={{flex:1,backgroundColor:"#0099CC",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/03_news/press/")}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>ニュースリリース</Text>
              <Text style={{color:"white",fontSize:18}}>公式プレス記事はこちら</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
          <TouchableOpacity style={{flex:1,backgroundColor:"#0099CC",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/teiki/")}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>定期運賃計算</Text>
              <Text style={{color:"white",fontSize:18}}>通常/学生/快て〜き等はこちら</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
          <TouchableOpacity style={{flex:1,backgroundColor:"#0099CC",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>_handlePressButtonAsync("https://www.jr-shikoku.co.jp/04_company/group/sp/")}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>JR四国のお店・サービス</Text>
              <Text style={{color:"white",fontSize:18}}>JR四国グループの施設をご案内</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
          <View style={{flexDirection:"row"}}>
            <TouchableOpacity style={{flex:1,backgroundColor:"#729FCF",borderColor:"#0099CC",padding:10,borderWidth:1,margin:2,alignItems:"center"}} onPress={()=>_handlePressButtonAsync("https://www.jr-odekake.net/smt/")}>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>時刻・運賃計算</Text>
              <Text style={{color:"white",fontWeight:"bold",fontSize:18}}>(マイ・ダイヤ)</Text>
              <Foundation name="yen" color="white" size={50}/>
              <Text style={{color:"white"}}>マイ・ダイヤはJR西日本提供のサービスです。</Text>
            </TouchableOpacity>
            <TouchableOpacity style={{flex:1,backgroundColor:"#8AE234",borderColor:"#0099CC",padding:10,borderWidth:1,margin:2,alignItems:"center"}} onPress={()=>Linking.openURL("tel:0570-00-4592")}>
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>JR四国案内センター</Text>
              <Foundation name="telephone" color="white" size={50}/>
              <Text style={{color:"white"}}>0570-00-4592</Text>
              <Text style={{color:"white"}}>(8:00~20:00 年中無休)</Text>
              <Text style={{color:"white"}}>(通話料がかかります)</Text>
            </TouchableOpacity>
          </View>
          <View style={{backgroundColor:"#0099CC",borderRadius:10,margin:10,borderColor:"black",borderWidth:2}}>
            <View style={{padding:10,flexDirection:"row",alignItems:"center"}}>
              <MaterialCommunityIcons name="twitter"style={{padding:5}} color="white" size={30}/>
              <Text style={{fontSize:30,fontWeight:"bold",color:"white"}}>公式Twitter一族</Text>
            </View>
            <View style={{padding:10,backgroundColor:"white",borderBottomLeftRadius:10,borderBottomRightRadius:10}}>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/JRshikoku_tokyo")}>
                  <Text>JR四国 東京営業情報【公式】</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/JRshikoku_osaka")}>
                  <Text>JR四国　大阪営業部【公式】</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/shikoku_DC")}>
                  <Text>JR四国営業部 四国DC情報【公式】</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/jr_shikoku_info")}>
                  <Text>JR四国運行情報Twitter</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/Smile_Eki_Chan")}>
                  <Text>JR四国いそうろう妖精 すまいるえきちゃん♡【公式】</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/JR_Shikoku_DPT")}>
                  <Text>JR四国デザインPT♡</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
              <ListItem onPress={()=>Linking.openURL("https://twitter.com/PT2nd_Yuki")}>
                  <Text>JR四国デザインPT弐号◇</Text>
                  <View style={{flex:1}}/>
                  <Icon name="chevron-right" size={20}/>
              </ListItem>
            </View>
          </View> 
          <Text style={{fontWeight:"bold",fontSize:20}}>このアプリについて</Text>
          <Text>このアプリはXprocess(HARUKIN)が製作しているJR四国の完全非公式アシストアプリケーションです。このアプリに関することでのJR四国公式へ問合せすることはお控えください。以下のTwitterよりお願いします。</Text>
          <Text>2021/6/23 4.0公開！ホーム画面を大改造しました。</Text>
          <TouchableOpacity style={{flex:1,backgroundColor:"#CC0000",padding:10,height:70,alignItems:"center",alignContent:"center",margin:2}} onPress={()=>{count < 10 ? (Linking.openURL("https://twitter.com/Xprocess_main"),setCount(count+1)):navigation.navigate("test")}}>
            <View style={{flex:1}} />
              <Text style={{color:"white",fontWeight:"bold",fontSize:20}}>XprocessのTwitter</Text>
              <Text style={{color:"white",fontSize:18}}>制作運営のTwitterです。</Text>
            <View style={{flex:1}} />
          </TouchableOpacity>
        </ScrollView>
        <ActionSheet ref={actionSheetRef}gestureEnabled CustomHeaderComponent={()=>{}}>
          <View style={{backgroundColor:"#0099CC",borderRadius:5,borderColor:"dark",borderWidth:1}}>
            <View style={{height:26,width:"100%",}}>
              <View style={{ height: 6, width: 45, borderRadius: 100, backgroundColor: "#f0f0f0", marginVertical: 10, alignSelf: "center",}} />
            </View>
            <View style={{padding:10,flexDirection:"row",alignItems:"center"}}>
                  <Text style={{fontSize:30,fontWeight:"bold",color:"white"}}>列車遅延速報EX</Text>
                  <View style={{flex:1}} />
                  {/* <TouchableOpacity style={{padding:10,backgroundColor:"white",alignContent:"center"}} onPress={() => {doFetch()}}>
                    <Text style={{fontSize:20,fontWeight:"bold",color:"#0099CC"}}>最新の情報へ更新</Text>
                  </TouchableOpacity> */}
                  <Text style={{fontSize:30,fontWeight:"bold",color:"white"}}>{getTime ? getTime.toLocaleTimeString('ja-JP').split(":")[0]+":"+getTime.toLocaleTimeString('ja-JP').split(":")[1]: NaN} </Text>
                  <Ionicons name="reload" color="white" size={30} style={{margin:5}} onPress={() => {LayoutAnimation.easeInEaseOut(),setLoadingDelayData(true),doFetch()}}/>
                </View>
            <ScrollView>

                <View style={{padding:10,backgroundColor:"white",borderBottomLeftRadius:5,borderBottomRightRadius:5}}>
                  {loadingDelayData ?
                   <View style={{alignItems:"center"}}>
                    <LottieView ref={LottieRef2} style={{ width: 150, height: 150, backgroundColor: '#fff',}} source={require('./assets/51690-loading-diamonds.json')}/>
                  </View> 
                  : delayData ? delayData.map((d)=>{
                    let data = d.split(" ");
                    console.log(data);
                    return (
                      <View style={{flexDirection:"row"}}>
                        <Text style={{flex:15,fontSize:20}}>{data[0].replace("\n","")}</Text>
                        <Text style={{flex:5,fontSize:20}}>{data[1]}</Text>
                        <Text style={{flex:6,fontSize:20}}>{data[3]}</Text>
                      </View>
                    );
                  }) : <Text>現在、5分以上の遅れはありません。</Text>}  
                </View>
            
            <View style={{padding:10}}>
              <Text style={{fontSize:20,fontWeight:"bold",color:"white"}}>列車遅延情報EXについて</Text>
              <Text style={{color:"white"}} >列車遅延情報をJR四国公式列車運行情報より5分毎に取得します。Twitterにて投稿している内容と同一のものとなります。</Text>
            </View>  
            <TouchableOpacity style={{padding:10,flexDirection:"row",borderColor:"white",borderWidth:1,margin:10,borderRadius:5,alignItems:"center"}} onPress={()=>Linking.openURL("https://twitter.com/JRSTrainfoEX")}>
              <MaterialCommunityIcons name="twitter" color="white" size={30}/>
              <View style={{flex:1}} />
              <Text style={{fontSize:25,fontWeight:"bold",color:"white"}}>TwitterBOTはこちら！</Text>
              <View style={{flex:1}} />
              <Text style={{fontSize:25,fontWeight:"bold",color:"white"}}>→</Text>
            </TouchableOpacity>
              
            </ScrollView>
          </View>    
         
        </ActionSheet>
      </View>
    );
}
